//首页初始化
let activityInfo

$(function () {
  $('.local-time').text(localGMTTime(0))
  let remSize = getComputedStyle(window.document.documentElement)['font-size']
  console.log('当前版本bruce20200702')
  clientInit()
  generateMarquee()

  //jsbridge不稳定,获取不到userInfo时从缓存获取
  if (location.search.indexOf('isDevelop') > -1 || localStorage.getItem('clientUserInfo')) {
    getActivityInfo()
  }

  //ios返回上一页不刷新
  let u = navigator.userAgent;
  let isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);

  if (isIOS) {
    window.onpageshow = function (event) {
      if (event.persisted) {
        window.location.reload()
      }
    };
  }
})

//客户端初始化
function clientInit () {
  callHandler(100, {}, (res) => {
    console.log('执行callHandler 100')
    localStorage.setItem(
      'clientUserInfo',
      JSON.stringify(JSON.parse(decodeURIComponent(res)).data)
    )
    userInfo = JSON.parse(decodeURIComponent(res)).data

    //这个时候保证userInfo有数据
    getActivityInfo()

    listenNavBackClicked()
  });
  // 预加载所有广告
  // indexBannerAd: 67, //首页底部原生广告
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.indexBannerAd,
  }, () => {});
  // lotteryBannerAd: 68, //转盘底部原生广告
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.lotteryBannerAd,
  }, () => {});
  // adIdAddChance: 69, //看广告加机会，插屏
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdAddChance,
  }, () => {});
  // adIdDouble: 70, //翻倍广告，插屏
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdDouble,
  }, () => {});
  // adIdRetry: 71, //复活，插屏
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdRetry,
  }, () => {});
  // adIdArms: 72, //看广告抽武器，插屏
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdArms,
  }, () => {});
  // adIdPrize: 73, // 转盘奖励广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdPrize,
  }, () => {});
  // adIdBannerDouble: 74, //已经翻倍后弹窗广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdBannerDouble,
  }, () => {});
  // adIdBannerRetried: 75, //已经复活后的弹窗广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdBannerRetried,
  }, () => {});
  // adIdChanceSuccess: 76, //看广告加机会弹窗广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdChanceSuccess,
  }, () => {});
  // adIdKnifeCollect: 77, //抽武器弹窗广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdKnifeCollect,
  }, () => {});
  // adIdIndexTreasure: 78,//首页插屏广告,弹窗
  callHandler(5401, {
    campaignId: baseInfo.campaignId,
    adId: baseInfo.adIdIndexTreasure,
  }, () => {});
}

//监听导航栏回调
function listenNavBackClicked () {
  navBackClicked(5601, 1, userInfo.pid, userInfo.version).then((res) => {

    console.log('navBackClicked', decodeURIComponent(res))
    if (decodeURIComponent(res).indexOf('5601') > -1) {

      if (activityInfo.remainPlayTimes > 0) {
        $('.modal').css('display', 'block')
        $('.leavel-content-info').css('display', 'block')
        $('.leavel-content-info .important-font').text(activityInfo.remainPlayTimes)

        //右上角的【关闭弹窗】按钮图标延迟3秒显示
        setTimeout(() => {
          $('.modal-close-icon').css('display', 'block')
        }, 3000)
      } else {
        backWebview(5601, userInfo.pid, userInfo.version)
      }

    } else {
      //看广告也触发了回调，懒得找客户端了，--bruce
      console.log('其他触发了导航栏点击回调')
      listenNavBackClicked()
    }
  })
}

//跑马灯
function generateMarquee () {
  var marqueelist = new Array(10)
  var str = ''
  $.each(marqueelist, (index, item) => {
    if (index % 2) {
      str =
        str +
        `<li class="header-carsoule-item">${makeRandomChar(
          Math.floor(Math.random() * 7) + 2
        )}***  completed 10 levels and earned ${
        baseInfo.successPrize[
        Math.floor(Math.random() * baseInfo.successPrize.length)
        ]
        } credits</li>`
    } else {
      str =
        str +
        `<li class="header-carsoule-item">${makeRandomChar(
          Math.floor(Math.random() * 7) + 2
        )}*** opened credit box and found ${
        baseInfo.treasurePrize[
        Math.floor(Math.random() * baseInfo.treasurePrize.length)
        ]
        } credits</li>`
    }
  })
  $('#header-carsoule-list').append(str)
  marquee('#header-carsoule-wrapper', '#header-carsoule-list', 3)
}

//server返回的初始化活动内容
function getActivityInfo () {
  console.log('执行getActivityInfo函数')
  let appName = Number(userInfo.pid) === 3 ? 'TalkU' : 'Dingtone'
  $('.appName').text(appName)
  homePageInit().then(res => {
    if (res.Result === 1 && res.data) {

      activityInfo = res.data
      localStorage.setItem('knifeGameActivityInfo', JSON.stringify(activityInfo))

      //能量
      $('.energy-number').text(activityInfo.remainPlayTimes)

      //当前武器
      $('.index-knife-icon').css('backgroundImage', `url('./img/arms-item${activityInfo.weaponIdInUse}.png')`)

      if (activityInfo.watchingGetPlayTimes >= activityInfo.watchingGetPlayTimesLimit) {
        $('.ad-video-tag').css('display', 'none')
      }

      //新用户
      if (activityInfo.newUser) {
        ga('send', 'event', 'dingtone_knife_game', 'knife_game_newer_play', 'NewPlayerGuide', 1);
        $('.modal').css('display', 'block')
        $('.newer-content-info').css('display', 'block')
        sessionStorage.setItem('newUser', 1)
      } else {
        callHandler(
          5402,
          {
            campaignId: baseInfo.campaignId,
            adId: baseInfo.indexBannerAd,
            content: 1,
          },
          () => { }
        )
      }

      //宝箱
      if (!activityInfo.treasureBoxOwned) {
        $('.display-show-area .treasure-box-area').css('display', 'none')
      } else {
        //拥有宝箱,宝箱倒计时
        $('.display-show-area .treasure-box-area').css('display', 'block')
        treasureCountdown(activityInfo.treasureBoxOpenTime)
        $('.count-down').css('display', 'block')
      }

      //push开关
      if (activityInfo.enableNotice) {
        $('.on-area').addClass('active-switch')
      } else {
        $('.off-area').addClass('off-active-switch')
      }

      localStorage.setItem('knifeGameActivityInfo', JSON.stringify(activityInfo))
    } else {
      console.log('首页初始化失败', res)
    }
  })
    .catch(err => {
      console.log('首页初始化失败', err)
    })
}

//倒计时
function treasureCountdown (treasureBoxOpenTime) {
  var count = 0
  let timeId = setInterval(() => {
    count++
    let timeObj = countdown(treasureBoxOpenTime, 1)
    $('.count-down').text(
      `${timeObj.hour}:${timeObj.minute}:${timeObj.secoend}`
    )

    if (
      timeObj.hour === '00' &&
      timeObj.minute === '00' &&
      timeObj.secoend === '00'
    ) {
      clearInterval(timeId)
      $('.count-down').css('display', 'none')
    }
  }, 1000)
}

//打开宝箱
var treasuring = false
$(document).on('touchstart', '.display-show-area .treasure-box-area', () => {
  console.log('领取宝箱')
  treasuring = false

  //没有宝箱
  if (!activityInfo.treasureBoxOwned) {
    return
  }

  if (treasuring) {
    return
  }
  treasuring = !treasuring

  //开启宝箱
  if (
    activityInfo.treasureBoxOpenTime <= new Date().getTime()
  ) {
    //有奖广告提前关闭,没有任何回调
    ga('send', 'event', 'dingtone_knife_game', 'knife_game_double', 'knife_game_double_btn', 1);
    adPreWatch(5400, baseInfo.campaignId, baseInfo.adIdIndexTreasure)
    setTimeout(() => {
      adPreWatch(5401, baseInfo.campaignId, baseInfo.adIdIndexTreasure)
    }, 5000)
    ga('send', 'event', 'dingtone_knife_game', 'WatchAdsSuccess', `ad=${baseInfo.adIdIndexTreasure}`, 1);

    openTreasure().then((res) => {
      if (res.Result === 1 && res.data) {
        ga('send', 'event', 'dingtone_knife_game', `knife_game_opentreasure`, 'OpenCreditBox', 1);
        console.log('开启宝箱成功')
        let creditNum = Number(res.data) / 100
        $('.credit-number').text(creditNum)
        $('.modal').css('display', 'block')
        $('.open-treasure-content-info').css('display', 'block')
        treasuring = false

        //右上角的【关闭弹窗】按钮图标延迟3秒显示
        setTimeout(() => {
          $('.modal-close-icon').css('display', 'block')
        }, 3000)
      } else {
        treasuring = false
      }
    })
      .catch(err => {
        treasuring = false
        console.log('开启宝箱失败', err)
      })
  } else {
    Toast.init()
    Toast.show(
      `Not ready yet<br/>
       Please wait...`,
      3000
    )
    treasuring = false
    setTimeout(function () {
      Toast.hide()
    }, 3000)
  }
})

//开始游戏
$(document).on('click', '.play-area-wrapper .start-btn', () => {
  console.log('开始游戏的操作')
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_start', 'StartGame', 1);

  //为0则判断当日看视频加机会的次数是否用完
  if (!activityInfo.remainPlayTimes) {

    //有看广告加机会
    if (activityInfo.watchingGetPlayTimes < activityInfo.watchingGetPlayTimesLimit) {
      $('.modal').css('display', 'block')
      $('.game-chance-content-info').css('display', 'block')

      //延迟3秒出现
      setTimeout(() => {
        $('.modal-close-icon').fadeIn()
      }, 3000)
      return

    } else {

      //没有看广告加机会
      Toast.init()
      Toast.show(`Chances used out<br/>
      You'll get more free chances next day!
      `, 3000)
      setTimeout(function () {
        Toast.hide()
      }, 3000)
      return
    }
  }

  openNewPage('./play.html')
})

$(document).on('click', '.leavel-btn', () => {
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_leavel_play', 'knife_game_leavel_btn', 1);
  openNewPage('./play.html')
})

$(document).on('click', '.newer-content-info .modal-green-btn', () => {
  console.log('点击了新手引导')
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_newer_play', 'NewPlayerPlayNow', 1);
  openNewPage('./play.html')
})

//跳转武器库
$(document).on('click', '.knife-button', () => {
  console.log('跳转武器库操作')
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_goarms', 'KnifeListEntry', 1);
  openNewPage('./arms.html')
})

//跳转新页面
function openNewPage (url) {
  closeAd5402()
  window.location.href = url + window.location.search
}

//观看广告加机会
var adding = false
$(document).on('click', '.video-button', () => {
  // console.log('观看广告加机会')
  console.log('adding------------', adding)
  if (adding) {
    return
  }
  adding = !adding
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_watchvideo', 'AddGameChanceEntry', 1);
  //看视频次数已达上限
  if (activityInfo.watchingGetPlayTimes >= activityInfo.watchingGetPlayTimesLimit) {
    Toast.init()
    Toast.show('You have reached the limit today', 3000)
    setTimeout(function () {
      Toast.hide()
    }, 3000)
    adding = false
    return
  }

  addChance().then((res) => {
    if (res.Result === 1 && res.data) {
      console.log('看广告加机会成功', res)
      adding = false
      closeModal()
      getActivityInfo()
    } else {
      adding = false
      console.log('看广告加机会失败')
    }
  })
    .catch(err => {
      adding = false
      console.error('看广告加机会失败', err)
    })

  //播放广告
  watchVideo()

})

//push开关切换
$(document).on('touchstart', '.switch-area', () => {
  activityInfo.enableNotice = activityInfo.enableNotice === 1 ? 0 : 1
  ga('send', 'event', 'dingtone_knife_game', `knife_game_switch${activityInfo.enableNotice}`, 'knife_game_switch_btn', 1);
  switchLocalPush(activityInfo.enableNotice).then((res) => {
    if (res.Result === 1 && res.data) {
      if (activityInfo.enableNotice) {
        $('.off-area').removeClass('off-active-switch')
        $('.on-area').addClass('active-switch')
      } else {
        $('.on-area').removeClass('active-switch')
        $('.off-area').addClass('off-active-switch')
      }
    } else {
      console.log('push开关切换失败')
    }
  })
    .catch((err) => {
      console.error('push开关切换失败', err)
    })
})

$(document).on('click', '.sure-btn', () => {
  closeModal()
})

//播放插屏广告
function watchVideo () {
  console.log('watchVideo--------')
  callHandler(
    5400,
    {
      campaignId: baseInfo.campaignId,
      adId: baseInfo.adIdAddChance,
    },
    () => { }
  )
  setTimeout(() => {
    adPreWatch(5401, baseInfo.campaignId, baseInfo.adIdAddChance)
  }, 5000)
  ga('send', 'event', 'dingtone_knife_game', 'WatchAdsSuccess', `ad=${baseInfo.adIdAddChance}`, 1);
}

//关闭5402广告
function closeAd5402 () {
  callHandler(
    5402,
    {
      campaignId: baseInfo.campaignId,
      adId: baseInfo.indexBannerAd,
      content: 0,
    },
    () => { }
  )
}

//关闭弹窗
function closeModal () {
  $('.modal').css('display', 'none')
  $('.game-chance-content-info').css('display', 'none')
  $('.open-treasure-content-info').css('display', 'none')
  $('.newer-content-info').css('display', 'none')
  $('.leavel-content-info').css('display', 'none')
}

//退出webvie
$(document).on('click', '#backwebview', () => {
  console.log('退出webview')
  backWebview(5601, userInfo.pid, userInfo.version)
})

$(document).on('click', '.modal-close-icon', () => {
  closeModal()
})

$('.open-treasure-content-info>.start-btn').click(() => {
  activityInfo.treasureBoxOwned = 0
  closeModal()
  $('.display-show-area .treasure-box-area').css('display', 'none')
})
