var hg = null

let retryInfo
function addClass(element, new_name) {
  if (!element || !new_name) return false
  if (element.className) {
    var old_class_name = element.className
    element.className = old_class_name + ' ' + new_name
  } else {
    element.className = new_name
  }
  return true
}
function removeClass(element, class_name) {
  if (!element || !class_name) return false
  if (!element.className) return false
  var all_names = element.className.split(' ')
  for (var i = 0; i < all_names.length; i++) {
    if (all_names[i] === class_name) {
      all_names.splice(i, 1)
      element.className = ''
      for (var j = 0; j < all_names.length; j++) {
        element.className += ' '
        element.className += all_names[j]
      }
      return true
    }
  }
}
var orderId = null
$(function () {
  searchRetryChance()
    .then((res) => {
      if (res.Result === 1 && res.data) {
        console.log('查询复活机会成功')
        retryInfo = res.data
        retryInfo.isRetry = false

      } else {
        console.log('查询复活机会失败')
      }
    })
    .catch((err) => {
      console.error('查询复活机会失败', err)
    })

  $('.close').on('click', function () {
    if (window.isH5) {
      window.history.go(-1)
    } else {
      wx.miniProgram.navigateBack()
    }
  })
  document
    .getElementById('levelSwitchBox')
    .addEventListener('webkitAnimationEnd', function () {
      $('#levelSwitchBox').css('display', 'none')
      // $("#levelSwitchBoxMain").attr("src", "img/level_2_mains.jpg?v=1.0.0")
      $('#levelSwitchBox').removeClass('hidden')
    })
  // $("#levelSwitchBox").addClass("hidden")
  if (!hg) {
    createHg(false)
  }
})
function playAudioInWechat(obj) {
  if (window.WeixinJSBridge) {
    WeixinJSBridge.invoke(
      'getNetworkType',
      {},
      function (e) {
        obj.currentTime = 0
        obj.play()
        console.log(22, obj)
      },
      false
    )
  } else {
    document.addEventListener(
      'WeixinJSBridgeReady',
      function () {
        WeixinJSBridge.invoke('getNetworkType', {}, function (e) {
          obj.currentTime = 0
          obj.play()
        })
        console.log(22, obj)
      },
      false
    )
  }
  console.log(22, obj)
}
function createHg(GAMEMODE) {
  // 初始化游戏, 两个参数分别表示"游戏所处的canvas画布元素"和"关卡设置, 可以省略(省略后将使用默认设置)"
  hg = new HardestGame(document.getElementById('gameStage'), GAMEMODE)
  //游戏成功过关
  hg.levelSuccessHandle = function () {
    console.log('levelSuccessHandle游戏成功过关')
    if (hg.level < 11) {
      // if(hg.level<4){

      console.log('hg.level==', hg.level)
      document.getElementById('levelbox').innerHTML = hg.level
      var time = 4;
      var interval = setInterval(function () {
        time--;
        if (time <= 0) {
          clearInterval(interval)
          hg.gameContinue(true)
        }
      }, 50)
    } else {
      if (sessionStorage.getItem('currentLevel')) {
        sessionStorage.removeItem('currentLevel')
      }
      lotteryPageInit(hg.level - 1)
    }
  }
  //游戏失败结束
  hg.gameOverHandle = function () {
    clearInterval(timeboxInterval)
    // hg = null;
    // if (hg) { delete hg; }
    $('#app').addClass('blur')
    var level = this.level

    console.log('this.level======+++++++', this.level)

    // 游戏结束必须调用，保证开始游戏次数和游戏结束次数相等，server有校验,奇怪的设计
    lotteryPageInit(this.level - 1)

    // 游戏结束后，如果该局游戏中通过关卡数不低于3，出现抽奖转盘/复活弹窗
    if (this.level > 3 && this.level <= 10) {
      //有复活机会时显示复活弹窗，无则显示抽奖转盘,并且每局游戏只允许复活一次
      console.log('游戏结束3', retryInfo.isRetry, retryInfo.reviveTimes, retryInfo.reviveTimesLimit)
      if (
        retryInfo.reviveTimes < retryInfo.reviveTimesLimit && !retryInfo.isRetry
      ) {
        //暂停游戏
        hg.gamePause(this.level)
        sessionStorage.setItem('currentLevel', this.level)

        //复活广告预加载
        callHandler(
          5401,
          {
            campaignId: window.baseInfo.campaignId,
            adId: window.baseInfo.adIdRetry,
          },
          (res) => {
            console.log(
              '广告加机会预加载成功',
              JSON.parse(decodeURIComponent(res))
            )
          }
        )

        //显示复活的弹窗
        $('.modal').css('display', 'block')
        ga('send', 'event', 'dingtone_knife_game', 'WatchAdsRetryGuide', 'WatchAdsRetryGuide', 1);
        $('.modal-level-number').text(11 - this.level)
        $('.failed-chance-content-info').css('display', 'block')
      } else {
        //没有复活机会,显示转盘
        if (sessionStorage.getItem('currentLevel')) {
          sessionStorage.removeItem('currentLevel')
        }
      }
    } else {
      // 不足三关，显示失败弹窗
      $('.modal').css('display', 'block')
      $('.failed-nochance-content-info').css('display', 'block')
    }

    //延迟3s出现
    showDelayTime('.modal-close-icon')
  }
  //初始化游戏
  hg.init()
  hg.canvas.parentNode.style.width = hg.canvas.width + 'px'
  hg.canvas.parentNode.style.height = hg.canvas.height + 'px'
  //游戏开始
  hg.gameStart()
  console.log('hg.gameStart()')
  document.getElementById('levelbox').innerHTML = hg.level
  return true
}

//复活
var retrying = false
$(document).on('click', '.retry-btn', () => {
  console.log('复活了')
  if (retrying) {
    return
  }
  retrying = !retrying
  adPreWatch(5400, window.baseInfo.campaignId, window.baseInfo.adIdRetry)
  setTimeout(() => {
    adPreWatch(5401, window.baseInfo.campaignId, window.baseInfo.adIdRetry)
  }, 5000)
  
  ga('send', 'event', 'dingtone_knife_game', 'WatchAdsSuccess', `ad=${window.baseInfo.adIdRetry}`, 1);
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_retry', 'knife_game_retry_btn', 1);
  gameRetry()
    .then((res) => {
      if (res.Result === 1 && res.data) {
        $('.failed-chance-content-info').css('display', 'none')

        console.log('复活成功1', retryInfo)

        $('.resurrection-content-info').css('display', 'block')

        $('.modal').css('display', 'block')
        console.log($('.hor-ver-center-center').filter(function(item) {return $(this).css('display')==='block'})[0].offsetWidth)
        console.log($('.hor-ver-center-center').filter(function(item) {return $(this).css('display')==='block'})[0].className)
        console.log($('.hor-ver-center-center').filter(function(item) {return $(this).css('display')==='block'})[0])
        var popHieght = $('.modal .resurrection-content-info').filter(function(item) {return $(this).css('display')==='block'})[0].offsetHeight
        var dpr = parseInt(document.querySelector('html').getAttribute('data-dpr'))
        // 显示复活成功弹窗下的广告
        bannerAdHandle(
          userInfo.pid,
          userInfo.version,
          baseInfo.campaignId,
          baseInfo.adIdBannerRetried,
          popHieght
        ).then((res) => {
          if (!res) {
            $('.hor-ver-center-center').css('top', 0)
          } else {
            let topHeight = res  + 'px'
            $('.hor-ver-center-center')
              .css('top', topHeight)
              .css('bottom', 'auto')
          }
        })

        getActivityInfo()
        retryInfo.reviveTimes = retryInfo.reviveTimes + 1
        retryInfo.isRetry = true
        // $('.failed-chance-content-info').css('display', 'none')

        // console.log('复活成功1', retryInfo)

        // $('.resurrection-content-info').css('display', 'block')

        // $('.modal').css('display', 'block')
        showDelayTime('.modal-close-icon')
        retrying = false
      } else {
        console.log('复活失败', res)
        retrying = false
      }
    })
    .catch((err) => {
      retrying = false
      console.error('复活失败', err)
    })
})

//继续游戏
$(document).on('click', '.continue-btn', () => {
  console.log('继续游戏2')
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_continue', 'knife_game_continue_btn', 1);
  closeModal('all')
  $('#app').removeClass('blur')
  document.getElementById('levelbox').innerHTML = Number(
    sessionStorage.getItem('currentLevel')
  )

  hg.BulletCirclesIndexInit()
  hg.gameContinue(true)

  // playPageInit()
  // console.log('session', Number(sessionStorage.getItem('currentLevel')))
  // hg.levelSuccessHandle(Number(sessionStorage.getItem('currentLevel')))
})

function truntableText(level) {
  $('.truntable').css('display', 'block')
  console.log('level===============', level)
  //每日前3次转盘出现时提示当日前3次抽奖必得叮咚币奖励
  if (level >= 10 && playPageInfo.lotteryId <= 3) {
    //通过第10关,有叮咚币奖励
    $('.lottery-turntable-text').html(
      `<p><span>All levels completed!</span></p><p>Get credits rewards for</p><p><span>the first 3 spins</span>  everyday!</p>`
    )
  } else if (level >= 10 && playPageInfo.lotteryId > 3) {
    //通过第10关,没有叮咚币奖励
    $('.lottery-turntable-text').html(
      `<p><span>All levels completed!</span></p><p>Spin and try your luck!</p>`
    )
  } else if (level < 10 && playPageInfo.lotteryId <= 3) {
    //未通关,有叮咚币奖励
    $('.lottery-turntable-text').html(
      `<p>You complete <span>${
      level
      }</span> levels!</p><p>Get credits rewards for</p><p><span>the first 3 spins</span> everyday!</p>`
    )
  } else {
    //未通关,没有叮咚币奖励
    $('.lottery-turntable-text').html(
      `<p>You complete <span>${
      level
      }</span> levels!</p><p>More levels you complete, </p><p>more reward you can get!</p>`
    )
  }
}

//显示隐藏5402广告
function showHide5402Ad(campaignId, adId, isShow) {
  callHandler(
    5402,
    {
      campaignId,
      adId,
      content: isShow,
    },
    () => { }
  )
}

//转盘页面初始化
function lotteryPageInit(level) {
  turntableInit(level)
    .then((res) => {
      if (res.Result === 1) {
        playPageInfo.prizeList = res.data.lotteryPrizeList
        playPageInfo.lotteryId = res.data.lotteryId
        console.log('retryInfo.isRetrylotteryPageInit', retryInfo.isRetry)
        if ((level > 3 && retryInfo.isRetry) || level === 10 || retryInfo.reviveTimes >= retryInfo.reviveTimesLimit) {
          handleTurnTabel(level)
        }
      } else {
        console.log('转盘抽奖页面初始化失败', res)
      }
    })
    .catch((err) => {
      console.log('转盘抽奖页面初始化失败', err)
    })
}

function handleTurnTabel(level) {
  //显示5402广告
  showHide5402Ad(baseInfo.campaignId, baseInfo.lotteryBannerAd, 1)
  console.log('turntableInit11111', playPageInfo)

  //转盘选项
  $.each(playPageInfo.prizeList, (index, item) => {

     
    var userId123 = '';
    try {
      if (userInfo) {
        userId123 = userInfo.userId;
      }
      if (item['prizeType'] === 1 && item['prizeCount'] < 50) {
        ga('send', 'event', 'dingtone_knife_game', 'knife_game_lot_err', playPageInfo.lotteryId+ '_' + item['prizeType'] + '_' + item['prizeCount'] + '_' + userId123, 1);
      }
    } catch (error) {
    }
    try {
      if (userInfo) {
        userId123 = userInfo.userId;
      }
      if (item['prizeType'] === 2 && parseInt(item['prizeCount']) !== 1) {
        ga('send', 'event', 'dingtone_knife_game', 'knife_game_lot_err', playPageInfo.lotteryId+ '_' + item['prizeType'] + '_' + item['prizeCount'] + '_' + userId123, 1);
      }
    } catch (error) {
    }
    //转盘奖励都在变化,必须记录奖励的角度
    item['rotateDeg'] = 35 + 60 * index

    if (item['prizeType'] === 1) {
      //叮咚币,叮咚币被服务端乘以100了
      item['prizeCount'] = item['prizeCount'] / 100
      $(`.prize${index + 1} .prize-icon`).addClass('credit-prize-icon')
    } else if (item['prizeType'] === 2) {
      //宝箱
      $(`.prize${index + 1} .prize-icon`).addClass(
        'treasure-prize-icon'
      )
    } else if (item['prizeType'] === 3) {
      //果汁
      $(`.prize${index + 1} .prize-icon`).addClass('fruit-prize-icon')
    }
    $(`.prize${index + 1} .prize-number`).text(item['prizeCount'])
  })
  truntableText(level)
  startLottery()
  try {
    var userId123 = '';
    if (userInfo) {
      userId123 = userInfo.userId;
    }
    var baoxiangs = playPageInfo.prizeList.filter(function(item){return item['prizeType'] === 2})
    if (baoxiangs.length > 1) {
      ga('send', 'event', 'dingtone_knife_game', 'knife_game_lot_err', playPageInfo.lotteryId+ '_' + JSON.stringify(baoxiangs) + '_' + userId123, 1);
    }
  } catch (error) {
  }
}

//转盘抽奖
function startLottery(isRepeat) {
  lottery(playPageInfo.lotteryId)
    .then((res) => {
      if (res.Result === 1 && res.data) {
        console.log('转盘抽奖成功', res)
        prizeInfo = res.data

        console.log('prizeInfo===', prizeInfo)

        if (isRepeat) {
          let prizeFilter = playPageInfo.prizeList.filter((item) => {
            return item['prizeId'] === prizeInfo.prizeId
          })
          rotateFn(0, prizeFilter[0].rotateDeg, prizeInfo)
          try {
            ga('send', 'event', 'dingtone_knife_game', 'knife_game_lot_success', JSON.stringify(playPageInfo.prizeList)+ '_' + prizeInfo.prizeId, 1);
          } catch (error) {
          }
        }
      } else {
        console.log('转盘抽奖失败', res)
      }
    })
    .catch((err) => {
      console.log('转盘抽奖失败', err)
    })
}

// 复活弹窗,关闭弹窗,放弃复活，显示转盘奖励
$(document).on('click', '.retry-modal-close-icon', () => {
  ga('send', 'event', 'dingtone_knife_game', 'knife_game_giveupretry', 'knife_game_giveupretry_btn', 1);
  $('.modal .failed-chance-content-info').css('display', 'none')
  $('.modal').css('display', 'none')
  handleTurnTabel(Number(sessionStorage.getItem('currentLevel')) - 1)
  // if (window.screen.height < 640) {
  //   adNativeShow(5402, 0, baseInfo.campaignId, baseInfo.adIdBannerRetried, userInfo.pid, userInfo.version)
  // } else {
  //   hide5405Ad(baseInfo.adIdBannerRetried, baseInfo.campaignId)
  // }
  bannerAdHide(
    userInfo.pid,
    userInfo.version,
    baseInfo.campaignId,
    baseInfo.adIdBannerRetried,
    400
  )

})
